#ifndef __LOG_H__
#define __LOG_H__

#include <string>
#include "conf.h"
#include "corelibcfg.h"


class COREIMPORT LogAgent
{
    public:
        enum MessageType
        {
            T_ERROR,
            T_WARNING,
            T_INFO,
            T_DEBUG
        };
    
    public:
        virtual ~LogAgent() { };
        virtual void logMessage(MessageType type, const std::string& msg) = 0;
        static std::string formatMessage(MessageType type, const std::string& msg);
};


class COREIMPORT Log
{
    private:
        LogAgent *agent;
    
    public:
        Log();
        ~Log();

    public:
        void error(const std::string& msg);
        void warn(const std::string& msg);
        void info(const std::string& msg);
        void debug(const std::string& msg);
        void setAgent(HTable conf);
};


extern COREIMPORT Log masLog;


#endif

