#include <fstream>
#include "log_file.h"


FileLogAgent::FileLogAgent(HTable conf)
{
    std::string s(table_get_strs(conf, "file", "/tmp/asocks.log", NULL));
    filename = s;
}

FileLogAgent::~FileLogAgent()
{
}

void FileLogAgent::logMessage(MessageType type, const std::string& msg)
{
    lock.lock();
    std::ofstream of(filename.c_str(), std::ios::app);
    of << LogAgent::formatMessage(type, msg) << std::endl;
    of.close();
    lock.unlock();
}

