#include <syslog.h>
#include "log_syslog.h"


SyslogLogAgent::SyslogLogAgent(HTable conf)
{
    openlog("asocks", LOG_PID, LOG_DAEMON);
}

SyslogLogAgent::~SyslogLogAgent()
{
    closelog();
}

void SyslogLogAgent::logMessage(MessageType type, const std::string& msg)
{
    int t;
    switch (type)
    {
        case T_ERROR: t = LOG_ERR; break;
        case T_WARNING: t = LOG_WARNING; break;
        case T_DEBUG: t = LOG_DEBUG; break;
        default: t = LOG_INFO;
    }
    syslog(t, "%s", msg.c_str());
}

