#include "mediainfo.h"



MediaInfo::MediaInfo()
{
}


MediaInfo::MediaInfo(const MediaInfo& minfo): props(minfo.props)
{
}


MediaInfo::~MediaInfo()
{
}


void MediaInfo::setProperty(const std::string &name, const std::string &value)
{
    props[name] = value;
}


std::string MediaInfo::getProperty(const std::string &name)
{
    if (hasProperty(name))
        return props[name];
    else
        return "";
}


void MediaInfo::clear()
{
    props.clear();
}


bool MediaInfo::hasProperty(const std::string &name)
{
    return (props.count(name) > 0);
}

bool MediaInfo::isEmpty()
{
    return (props.size() == 0);
}


COREIMPORT bool operator == (const MediaInfo &mi1, const MediaInfo &mi2)
{
    return mi1.props == mi2.props;
}

