#ifndef __MEDIAINFO_H__
#define __MEDIAINFO_H__


#include <map>
#include <string>
#include "corelibcfg.h"


class COREIMPORT MediaInfo
{
    private:
        std::map<std::string, std::string> props;
    
    public:
        MediaInfo();
        MediaInfo(const MediaInfo& minfo);
        ~MediaInfo();

    public:
        void setProperty(const std::string &name, const std::string &value);
        std::string getProperty(const std::string &name);
        bool hasProperty(const std::string &name);
        void clear();
        bool isEmpty();
        friend bool operator == (const MediaInfo &mi1, const MediaInfo &mi2);
};


COREIMPORT bool operator == (const MediaInfo &mi1, const MediaInfo &mi2);

#endif

