#ifndef __MEDIATYPE_H__
#define __MEDIATYPE_H__


#include <string>
#include <set>
#include "corelibcfg.h"


class COREIMPORT MediaType
{
    protected:
        std::string type;
        std::string subtype;
    
    public:
        MediaType(const std::string &type, const std::string &subtype);
        MediaType(const MediaType &mtype);
        virtual ~MediaType();

    public:
        virtual std::string getType() const;
        virtual std::string getSubtype() const;
        virtual bool isEqual(const MediaType &mtype) const;
        virtual MediaType* clone() const;
        virtual std::string getMimeType() const;
        friend bool operator < (const MediaType &m1, const MediaType &m2);
};


COREIMPORT bool operator < (const MediaType &m1, const MediaType &m2);

COREIMPORT bool isSupportedMediaType(std::set<MediaType> &types, const MediaType &mediaType);


#endif

