#ifndef __MULTI_SOCK_H__
#define __MULTI_SOCK_H__

#include <sys/types.h>
#ifndef WIN32
#include <sys/socket.h>
#include <netinet/in.h>
#else
#include <winsock2.h>
#endif
#include "readsock.h"
#include "writesock.h"

class COREIMPORT MulticastSocket: public ReadSocket, public WriteSocket
{
    private:
        int sock;
        struct sockaddr_in sin;
        int addrLen;
    
    public:
        MulticastSocket(HTable params, bool output);
        virtual ~MulticastSocket();
    
    public:
        virtual int read(unsigned char* buf, int max_size);
        virtual int write(unsigned char* buf, int size);
        virtual bool isReadSelectable() { return true; };
        virtual int getSelectorReadDescr() { return sock; };
};

#endif

