#ifndef __PACKETIZER_H__
#define __PACKETIZER_H__


#include "mediatype.h"


class COREIMPORT PacketizerReceiver
{
    public:
        virtual ~PacketizerReceiver() { };
        virtual void addData(unsigned char *data, int length, double playTime, 
                const MediaType &mediaType) = 0;
};


class COREIMPORT Packetizer
{
    protected:
        PacketizerReceiver *recv;
    
    public:
        Packetizer(PacketizerReceiver *recv);
        virtual ~Packetizer() { };

    public:
        virtual void addData(unsigned char *data, int length) = 0;
        virtual void addData(unsigned char ch) = 0;
        virtual void setReceiver(PacketizerReceiver *recv);
};


class COREIMPORT PacketizerFactory
{
    public:
        virtual ~PacketizerFactory() { };
        virtual Packetizer* createPacketizer(const std::string &name, 
                PacketizerReceiver *recv=NULL) = 0;
};


#endif

