#ifndef __PLUGIN_H__
#define __PLUGIN_H__


#ifdef WIN32
#include <windows.h>
#endif
#include <string>
#include <vector>
#include "thread.h"
#include "conf.h"


#ifdef WIN32
#define ModuleHandler HINSTANCE
#else
#define ModuleHandler void*
#endif


class COREIMPORT Plugin
{
    public:
        virtual ~Plugin() { };
};


class COREIMPORT RunnablePlugin: public Plugin, public Thread
{
    public:
        virtual ~RunnablePlugin() { };
};


class COREIMPORT Loader
{
    public:
        virtual ~Loader() { };

    public:
        virtual void load(const std::string& path, const std::string& name, HTable descr) = 0;
};


class COREIMPORT GenericLoader: public Loader
{
    private:
        std::vector<ModuleHandler> handlers;
    
    public:
        GenericLoader() { };
        virtual ~GenericLoader();

    public:
        virtual void load(const std::string& path, const std::string& name, HTable descr);
};


void loadModules(HTable directories);


#ifdef WIN32
#define EXPORT_REGFUNC __declspec(dllexport) __stdcall
#else
#define EXPORT_REGFUNC
#endif


#endif

