#ifndef __SELECTOR_H__
#define __SELECTOR_H__


#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include "readsock.h"
#ifdef WIN32
#include "utils.h"
#endif

class COREIMPORT Selector
{
    private:
        fd_set fdset;
        int maxDescriptor;
        
    public:
        Selector();
        ~Selector();

    public:
        void clear();
        void addReadSocket(ReadSocket& sel);
        int waitForEvent();
        int waitForEvent(struct timeval& tv);
        bool canRead(ReadSocket& sel);
};

#endif

