#include <ctype.h>
#include <stdio.h>
#include <sys/time.h>
#include "utils.h"


COREIMPORT std::string toLowerCase(const std::string& str)
{
    std::string s;
    char sb[2];
    sb[1] = 0;
    int i, len = str.length();
    for (i = 0; i < len; i++)
    {
        sb[0] = tolower(str[i]);
        s.append(sb);
    }
    return s;
}


COREIMPORT std::string numToStr(int number)
{
    char buf[100];
    sprintf(buf, "%i", number);
    return buf;
}


COREIMPORT std::string numToStr(long long int number)
{
    char buf[100];
    sprintf(buf, "%lli", number);
    return buf;
}


COREIMPORT std::string numToStr(long int number)
{
    char buf[100];
    sprintf(buf, "%li", number);
    return buf;
}


COREIMPORT std::string numToStr(double number)
{
    char buf[100];
    sprintf(buf, "%f", number);
    return buf;
}



COREIMPORT int gettimeofday(struct timeval* tp)
{
#ifdef WIN32
    return gettimeofday(tp, (int*)NULL);
#else
    struct timezone tz;
    return gettimeofday(tp, &tz);
#endif
}


#ifdef WIN32
#include <sys/timeb.h>

COREIMPORT int gettimeofday(struct timeval* tp, int* /*tz*/) 
{
    struct timeb tb;
    ftime(&tb);
    tp->tv_sec = tb.time;
    tp->tv_usec = 1000*tb.millitm;
    return 0;
}

COREIMPORT int gettimeofday(struct timeval* tp, struct timezone* /*tz*/) 
{
    return gettimeofday(tp, (int*)NULL);
}


COREIMPORT void usleep(long long int usec)
{
    /*struct timeval tv;
    tv.tv_sec = usec / 1000000;
    tv.tv_usec = usec % 1000000;
    select(0, NULL, NULL, NULL, &tv);*/
   /* int msec = usec / 1000;
    if (msec > 2000)
        Sleep(msec - 1000); */
    Sleep(usec / 1000);
}

COREIMPORT void sleep(int sec)
{
    Sleep(sec * 1000);
}

#endif


COREIMPORT std::string inet_atos(unsigned long int addr)
{
    unsigned char *s = (unsigned char*)&addr;
    char buf[100];
    sprintf(buf, "%i.%i.%i.%i", s[0], s[1], s[2], s[3]);
    return std::string(buf);
}


COREIMPORT std::string readLine(std::istream& is)
{
    std::string s;
    char ch;

    while (is.good() && (! is.eof()))
    {
        ch = 0;
        is.read(&ch, 1);
        if ((! is.good()) || is.eof())
            break;
        if (ch == 0)
            break;
        if (ch == '\n')
            break;
        if (ch == '\r')
            continue;
        if (ch != 0)
            s += ch;
    }

    return s;
}


COREIMPORT std::string getFileExtLower(const std::string &s)
{
    char *filename = (char*)s.c_str();
    if (! filename)
        return "";
    
    int len = strlen(filename);

    if (len > 0)
    {
        int i = len - 1;
        while (i)
        {
            if (filename[i] == '.')
            {
                if (i == len - 1)
                    break;
                i++;
                char *buf = strdup(filename + i);                
                for (char *c = buf; *c; c++)
                    *c = tolower(*c);
                std::string s(buf);
                free(buf);
                return s;
            }
            i--;
        }
    }
    return "";
}

