#ifndef __UTILS_H__
#define __UTILS_H__

#include <string>
#include <iostream>
#include "corelibcfg.h"

COREIMPORT std::string toLowerCase(const std::string& str);
COREIMPORT std::string numToStr(int number);
COREIMPORT std::string numToStr(long int number);
COREIMPORT std::string numToStr(long long int number);
COREIMPORT std::string numToStr(double number);
COREIMPORT std::string inet_atos(unsigned long int addr);

COREIMPORT int gettimeofday(struct timeval* tp);

#ifdef WIN32
#include <winsock2.h>
struct timezone { };
COREIMPORT int gettimeofday(struct timeval* tp, struct timezone* /*tz*/);
COREIMPORT int gettimeofday(struct timeval* tp, int* /*tz*/);
COREIMPORT void usleep(long long int usec);
COREIMPORT void sleep(int sec);
#endif

COREIMPORT std::string readLine(std::istream& is);
COREIMPORT std::string getFileExtLower(const std::string &filename);

#endif

