include $(ROOT)/conf.mk

CXXFLAGS=-DCONFPATH=\"${CONFPATH}\" $(ENABLE_DEBUG) $(USER_CXXFLAGS)
LIBS=-L/usr/local/lib

AR=ar
RANLIB=ranlib
INSTALL=install
RM=rm
LN=ln

CXXSHARED=-fPIC -DPIC
LINKSHARED=$(CXX) -shared
MODCXXFLAGS=-I$(ROOT)/kernel
MODLNFLAGS=-L$(ROOT)/kernel -lmaserver
DLLEXT=so
MAINLNFLAGS=-Wl,--export-dynamic -rdynamic -Bdynamic
MODULESDIR=$(PREFIX)/lib/maserver/modules
LIBSDIR=$(PREFIX)/lib
LIBPREFIX=lib
LIBSUFFIX=.so

ifeq ($(SYSTEM_TYPE),linux)
CXXFLAGS+=-D_REENTRANT
LIBS+=-lpthread -ldl
endif

ifeq ($(SYSTEM_TYPE),freebsd)
CXXFLAGS+=-D_REENTRANT -D_THREAD_SAFE
LNFLAGS+=-pthread
endif

ifeq ($(SYSTEM_TYPE),solaris)
CXXFLAGS+=-D_REENTRANT -mt
LIBS+=-lthread -lpthread
endif

ifeq ($(SYSTEM_TYPE),solaris-gcc)
CXX=g++
CXXFLAGS+=-D_REENTRANT
LIBS+=-lthread -lpthread -lsocket -lresolv -lnsl
endif

ifeq ($(SYSTEM_TYPE),mingw)
CXXFLAGS+=-D_REENTRANT -mthreads
LIBS+=-lpthreadGCE -lws2_32 -lwsock32
LNFLAGS+=-mthreads
CC=gcc
CXX=g++
ENABLE_SYSLOG_LOGGING=no
DLLEXT=dll
DLLWRAP=dllwrap
LINKSHARED=$(DLLWRAP) --no-export-all-symbols --add-stdcall-alias --driver-name g++
CXXSHARED=
MODULESDIR=$(PREFIX)/modules
LIBSDIR=$(PREFIX)/bin
LIBPREFIX=
LIBSUFFIX=.dll
endif

ifeq ($(SYSTEM_TYPE),bcc)
CXXFLAGS+=-D_REENTRANT -mthreads
LIBS+=-lpthreadGCE -lws2_32 -lwsock32
LNFLAGS+=-mthreads
CC=gcc
CXX=g++
ENABLE_SYSLOG_LOGGING=no
DLLEXT=dll
DLLWRAP=dllwrap
LINKSHARED=$(DLLWRAP) --no-export-all-symbols --add-stdcall-alias --driver-name g++
LIBPREFIX=
LIBSUFFIX=.dll
endif

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $<

.c.o:
	$(CC) -c $(CXXFLAGS) $<

