#ifndef __DECODE_H__
#define __DECODE_H__


#include "maserver.h"


#ifdef WIN32
#ifdef BUILDING_DECODE
#define DECODEIMPORT __declspec (dllexport)
#else
#define DECODEIMPORT __declspec (dllimport)
#endif
#else
#define DECODEIMPORT
#endif


class DECODEIMPORT Decoder: public PacketizerReceiver
{
    public:
        virtual ~Decoder() { };
};


class DECODEIMPORT DecoderFactory
{
    public:
        virtual ~DecoderFactory() { };
        virtual bool isSupportedMedia(const MediaType &mediaType) = 0;
        virtual Decoder* createDecoder(const MediaType &mediaType,
                PacketizerReceiver *receiver, HTable conf) = 0;
};


class DECODEIMPORT DecoderRegistry: public Plugin
{
    private:
        std::map<std::string, DecoderFactory*> factories;
        
    public:
        DecoderRegistry() { };
        virtual ~DecoderRegistry();
        void registerDecoder(const std::string &name, DecoderFactory *factory);
        Decoder* createDecoder(const MediaType &mediaType, 
                PacketizerReceiver *receiver, HTable preferred);
};



#endif

