#ifndef __FILE_INPUT_H__
#define __FILE_INPUT_H__


#include "maserver.h"
#include "playlist.h"



class FileInput: public OutputUnit, public PacketizerReceiver
{
    private:
        PlaylistHandler *playlistHandler;
        double startTime;
        double playingTime;
        
    public:
        FileInput();
        FileInput(HTable conf);
        virtual ~FileInput();

    public:
        virtual std::set<MediaType> getAcceptedMediaTypes();
        virtual std::string getType() { return std::string("fileinput"); };
        virtual void addData(unsigned char *data, int length, double playTime, 
                const MediaType &mediaType);
        virtual void run();
};


class FileUnitFactory: public UnitFactory
{
    public:
        FileUnitFactory() { };
        virtual ~FileUnitFactory() { };
        virtual Unit* createUnit(const std::string &name, HTable conf);
};


#endif

