#ifndef __PLAYLIST_H__
#define __PLAYLIST_H__


#include "maserver.h"


#ifdef WIN32
#ifdef BUILDING_FILEINPUT
#define FILEIMPORT __declspec (dllexport)
#else
#define FILEIMPORT __declspec (dllimport)
#endif
#else
#define FILEIMPORT
#endif


class FILEIMPORT PlaylistHandler
{
    public:
        virtual ~PlaylistHandler() { };

    public:
        virtual std::string getNextSong() = 0;
};


PlaylistHandler* createPlaylistHandler(const std::string& type, HTable args);


class FILEIMPORT PlaylistFactory: public Plugin
{
    public:
        virtual ~PlaylistFactory() { };
        virtual PlaylistHandler* createPlaylist(HTable args) = 0;
};

#endif

