#ifndef __INTPLLIST_H__
#define __INTPLLIST_H__

#include <time.h>
#include <vector>
#include "maserver.h"
#include "playlist.h"


class InternalPlaylistHandler: public PlaylistHandler
{
    private:
        std::vector<std::string> songs;
        enum EOrder
        {
            Forward,
            Backward,
            Random,
            Shuffle
        } order;
        int current_song;
        bool updatePlaylist;
        time_t lastPlaylistMtime;
        time_t lastPlaylistCtime;
        int lastPlaylistSize;
        std::string playlistFilename;
        std::string blockFilename;
        std::string operDir;
        std::vector<std::string> operList;
        std::string deleteFile;
        std::string blockOper;
    
    public:
        InternalPlaylistHandler();
        InternalPlaylistHandler(HTable table);
        virtual ~InternalPlaylistHandler();

    private:
        void readPlaylist();
        void readSubPlaylist(const std::string& filename);
        bool isPlaylistUpdated();
        std::string getNextOperSong();
        
    public:
        virtual std::string getNextSong(); 
};


class InternalPlaylistFactory: public PlaylistFactory
{
    public:
        InternalPlaylistFactory();
        virtual ~InternalPlaylistFactory();
        virtual PlaylistHandler* createPlaylist(HTable args);
};


#endif

