#include "maserver.h"
#include "decode.h"


class ExternalMp3Decoder: public Decoder
{
    private:
        PacketizerReceiver *receiver;
        std::string program;
    
    public:
        ExternalMp3Decoder(const std::string &program, PacketizerReceiver *recv);
        virtual ~ExternalMp3Decoder();
        virtual void addData(unsigned char *data, int length, double playTime, 
                const MediaType &mediaType);
};


class ExternalMp3DecoderFactory: public DecoderFactory
{
    private:
        std::string program;
        
    public:
        ExternalMp3DecoderFactory(const std::string &program);
        virtual ~ExternalMp3DecoderFactory() { };
        virtual bool isSupportedMedia(const MediaType &mediaType);
        virtual Decoder* createDecoder(const MediaType &mediaType,
                PacketizerReceiver *receiver, HTable params);
};


class ExtMp3DecoderLoader: public Loader
{
    private:
        DecoderRegistry *registry;
        
    public:
        ExtMp3DecoderLoader();
        virtual ~ExtMp3DecoderLoader() { };
        virtual void load(const std::string& path, const std::string& name, 
                HTable descr);
};

