#ifndef __MP3FILEFORMAT_H__
#define __MP3FILEFORMAT_H__


#include "maserver.h"
#include "fileformats.h"


class Mp3FileFormat: public FileFormat
{
    private:
        MediaInfo minfo;
        long start;
        long size;
    
    public:
        Mp3FileFormat(const std::string &filename);
        virtual ~Mp3FileFormat() { };
        virtual void packetize(Interruptable *intr, PacketizerReceiver *receiver);
        virtual bool hasMediaInfo();
        virtual MediaInfo getMediaInfo();
};


class Mp3FileFormatFactory: public FileFormatFactory
{
    public:
        Mp3FileFormatFactory() { };
        virtual ~Mp3FileFormatFactory() { };
        virtual bool isOurFileByExt(const std::string &fileExtension);
        virtual bool isOurFileByContent(std::ifstream &stream,
                const std::string &fullname, const std::string &ext);
        virtual FileFormat* createFileFormat(const std::string &fullname);
};


#endif

