#include "maserver.h"
#include "mp3mediatype.h"


MP3MediaType::MP3MediaType(int abitrate, int astereo, int asamplerate):
        MediaType("audio", "mp3")
{
    bitrate = abitrate;
    stereo = astereo;
    samplerate = asamplerate;
}

MP3MediaType::MP3MediaType(const MP3MediaType &mtype): MediaType("audio", "mp3")
{
    bitrate = mtype.bitrate;
    samplerate = mtype.samplerate;
    stereo = mtype.stereo;
}

MP3MediaType::~MP3MediaType()
{
}


int MP3MediaType::getBitrate()
{
    return bitrate;
}

int MP3MediaType::getStereo()
{
    return stereo;
}

int MP3MediaType::getSamplerate()
{
    return samplerate;
}


bool MP3MediaType::isEqual(const MediaType &mtype) const
{
    if ((mtype.getType() == "audio") && (mtype.getSubtype() == "mp3"))
    {
        MP3MediaType *mp3 = (MP3MediaType*)&mtype;
        if ((mp3->bitrate == bitrate) && (mp3->samplerate == samplerate) &&
                (mp3->stereo == stereo))
            return true;
    }
    return false;
}


MediaType* MP3MediaType::clone() const
{
    return new MP3MediaType(*this);
}


std::string MP3MediaType::getMimeType() const
{
    return "audio/mpeg";
}



extern "C" int EXPORT_REGFUNC register_mp3media_plugins()
{
    int res = 0;
 /*   try
    {
        Server::getServer()->addPacketizerFactory(std::string("mp3"), 
                (PacketizerFactory*)new MP3PacketizerFactory());
    }
    catch (MasException &e)
    {
        masLog.error(e.getMessage());
        res = 1;
    }
    catch (...)
    {
        res = 1;
    } */
    return res;
}

