#ifndef __MP3MEDIATYPE_H__
#define __MP3MEDIATYPE_H__


#include "mediatype.h"


#ifdef WIN32
#ifdef BUILDING_MP3DLL
#define MP3IMPORT __declspec (dllexport)
#else
#define MP3IMPORT __declspec (dllimport)
#endif
#else
#define MP3IMPORT
#endif


class MP3IMPORT MP3MediaType: public MediaType
{
    private:
        int bitrate;
        int stereo;
        int samplerate;
    
    public:
        MP3MediaType(int bitrate, int stereo, int samplerate);
        MP3MediaType(const MP3MediaType &mtype);
        virtual ~MP3MediaType();

    public:
        int getBitrate();
        int getStereo();
        int getSamplerate();
        virtual bool isEqual(const MediaType &mtype) const;
        virtual MediaType* clone() const;
        virtual std::string getMimeType() const;
};


#endif

