#ifndef __MP3PACKETIZER_H__
#define __MP3PACKETIZER_H__


#include "packetizer.h"
#include "mp3mediatype.h"


#ifdef WIN32
#define EXPORT __declspec (dllexport)
#else
#define EXPORT
#endif


typedef struct 
{
    int syncword;
    int layer;
    int version;
    int errorProtection;
    int bitrateIndex;
    int samplerateIndex;
    int padding;
    int extension;
    int mode;
    int modeExt;
    int copyright;
    int original;
    int emphasis;
    int stereo;
    int bitrate;
    int samplerate;
    int samples;
    int framesize;            
} MP3Header;



class EXPORT MP3Packetizer: public Packetizer
{
    private:
        unsigned char *buffer;
        int bufSize;
        int bufStart, bufEnd;
        int filled;
        bool findStart, waitForData;
        MP3Header mh;
        int dataRemaining;
        MP3MediaType *mtype;
    
    public:
        MP3Packetizer(PacketizerReceiver *recv);
        virtual ~MP3Packetizer();

    public:
        virtual void addData(unsigned char *data, int length);
        virtual void addData(unsigned char data);

    private:
        void clearState();
        void releasePacket();
        void checkForHeader();
};


class EXPORT MP3PacketizerFactory: public PacketizerFactory
{
    public:
        MP3PacketizerFactory() { };
        virtual ~MP3PacketizerFactory() { };
        virtual Packetizer* createPacketizer(const std::string &name, 
                PacketizerReceiver *recv=NULL);
};


#endif

