#include "mp3rtpparser.h"


Mp3RtpParser::Mp3RtpParser(PacketizerReceiver *recv)
{
    packetizer = Server::getServer()->createPacketizer("mp3", recv);
    if (! packetizer)
        throw MasException("mp3 packetizer not found");
}

Mp3RtpParser::~Mp3RtpParser()
{
    delete packetizer;
}

void Mp3RtpParser::parsePacket(unsigned char *data, int length)
{
    packetizer->addData(data, length);
}

void Mp3RtpParser::flush()
{
}



RtpPacketParser* Mp3RtpParserFactory::createParser(int payload, 
        PacketizerReceiver *recv)
{
    if (payload != 0x0E)
        throw MasException("Invalid mp3 payload type " + numToStr(payload));
    return new Mp3RtpParser(recv);
}


extern "C" int EXPORT_REGFUNC register_mp3rtpparser_plugins()
{
    int res = 0;
    try
    {
        RtpPacketParserRegistry *registry = (RtpPacketParserRegistry*)
            Server::getServer()->findPlugin("rtpPacketParserRegistry");
        if (! registry)
            throw MasException("rtpPacketParserRegistry plugin not found");
        registry->registerFactory(0x0E, new Mp3RtpParserFactory());
    }
    catch (MasException &e)
    {
        masLog.error(e.getMessage());
        res = 1;
    }
    catch (...)
    {
        res = 1;
    }
    return res;
}

