#ifndef __MP3_RTP_PRODUCER_H__
#define __MP3_RTP_PRODUCER_H__


#include "maserver.h"
#include "rtp.h"


class Mp3RtpProducer: public RtpPacketProducer
{
    private:
        unsigned char *buffer;
        int maxBufSize;
        int filled;
        int packetsCount;
        double packetsTime;
        RtpSender *sender;

    public:
        Mp3RtpProducer(RtpSender *sender, int maxBufSize=1500);
        virtual ~Mp3RtpProducer();
        virtual void makePackets(unsigned char *data, int length, 
                double playTime, const MediaType &mediaType);
        virtual void flush();
};


class Mp3RtpProducerFactory: public RtpPacketProducerFactory
{
    public:
        Mp3RtpProducerFactory() { };
        virtual ~Mp3RtpProducerFactory() { };
        virtual bool isSupportedMediaType(const MediaType &mediaType);
        virtual RtpPacketProducer* createPacketProducer(RtpSender *sender,
                const MediaType &mediaType);
};

#endif

