#include "maserver.h"
#include "rawaudio.h"


RawAudioMediaType::RawAudioMediaType(int astereo, int asamplerate, int aformat):
        MediaType("audio", "raw")
{
    format = aformat;
    stereo = astereo;
    samplerate = asamplerate;
}

RawAudioMediaType::RawAudioMediaType(const RawAudioMediaType &mtype): 
        MediaType("audio", "raw")
{
    samplerate = mtype.samplerate;
    stereo = mtype.stereo;
    format = mtype.format;
}

RawAudioMediaType::~RawAudioMediaType()
{
}


int RawAudioMediaType::getFormat()
{
    return format;
}

int RawAudioMediaType::getStereo()
{
    return stereo;
}

int RawAudioMediaType::getSamplerate()
{
    return samplerate;
}


bool RawAudioMediaType::isEqual(const MediaType &mtype) const
{
    if ((mtype.getType() == "audio") && (mtype.getSubtype() == "raw"))
    {
        RawAudioMediaType *raw = (RawAudioMediaType*)&mtype;
        if ((raw->format == format) && (raw->samplerate == samplerate) &&
                (raw->stereo == stereo))
            return true;
    }
    return false;
}


MediaType* RawAudioMediaType::clone() const
{
    return new RawAudioMediaType(*this);
}


std::string RawAudioMediaType::getMimeType() const
{
    return "audio/raw";
}



extern "C" int EXPORT_REGFUNC register_raudmed_plugins()
{
    return 0;
}

