#ifndef __RAWAUDIO_H__
#define __RAWAUDIO_H__


#include "mediatype.h"


#ifdef WIN32
#ifdef BUILDING_RAUDMEDDLL
#define RAUDIMPORT __declspec (dllexport)
#else
#define RAUDIMPORT __declspec (dllimport)
#endif
#else
#define RAUDIMPORT
#endif


class RAUDIMPORT RawAudioMediaType: public MediaType
{
    private:
        int stereo;
        int samplerate;
        int format;
    
    public:
        RawAudioMediaType(int stereo, int samplerate, int format);
        RawAudioMediaType(const RawAudioMediaType &mtype);
        virtual ~RawAudioMediaType();

    public:
        int getFormat();
        int getStereo();
        int getSamplerate();
        virtual bool isEqual(const MediaType &mtype) const;
        virtual MediaType* clone() const;
        virtual std::string getMimeType() const;
};


#endif

