#ifndef __RTP_OUTPUT_H__
#define __RTP_OUTPUT_H__


#include "maserver.h"


class Announcer: public Thread
{
    private:
       /* InputProtocol *input; */
        WriteSocket *socket;
        MediaInfo mediaInfo;
        Lock mediaLock;
    
    public:
        Announcer(const MediaInfo &mediaInfo, WriteSocket *s);
        virtual ~Announcer();

    public:
        virtual void run();
        void setMediaInfo(const MediaInfo &mediaInfo);
};


class RtpOutput: public SingleInputUnit
{
    private:
        WriteSocket* rtpSock;
        char block;
        WriteSocket* annSock;
        Announcer *announcer;
    
    public:
        RtpOutput();
        RtpOutput(HTable params);
        virtual ~RtpOutput();

    public:
        virtual std::set<MediaType> getAcceptedMediaTypes();
        virtual std::string getType() { return "rtpoutput"; };
        virtual void run();
};


class RtpOutputFactory: public UnitFactory
{
    public:
        RtpOutputFactory() { };
        virtual ~RtpOutputFactory() { };
        virtual Unit* createUnit(const std::string &name, HTable conf);
};


#endif

